#!/usr/bin/perl
#######################
##  AutoRank v2.0.0  ##
###################################################################################
##  accounts.cgi                                                                 ##
##  ------------                                                                 ##
##  This script controls the addition of sites to the member database            ##
###################################################################################

print "Content-type: text/html\n\n";
require "functions.cgi";
FUNCTIONS::script_error(1016, "variables.dat") unless(-e "$FUNCTIONS::SCRIPT_DATA_DIR/variables.dat");
FUNCTIONS::parse(1);

if($ENV{'REQUEST_METHOD'} eq "GET") {
  &display_add_form();
}    
elsif($ENV{'REQUEST_METHOD'} eq "POST") {  
  &start_addition_procedure();
}
exit;

##########################################  BEGIN SUBROUTINES  ##########################################

sub display_add_form {
  my(%template);
  
  $template{'EMAIL_FIELD'} = qq|<input type="text" name="E-Mail_RQ" size="30">|;
  $template{'SITE_TITLE_FIELD'} = qq|<input type="text" name="Site_Title_RQ" size="30" maxlength="$VARIABLES::TITLE_LENGTH">|;
  $template{'SITE_URL_FIELD'} = qq|<input type="text" name="Site_URL_RQ" size="50">|;
  $template{'DESCRIPTION_FIELD'} = qq|<input type="text" name="Description_RQ" size="50" maxlength="$VARIABLES::DESC_LENGTH">|;
  $template{'BANNER_URL_FIELD'} = qq|<input type="text" name="Banner_URL" size="50">|;
  $template{'USERNAME_FIELD'} = qq|<input type="text" name="Username_RQ" size="12" maxlength="8">|;
  $template{'PASSWORD_FIELD'} = qq|<input type="password" name="Password_RQ" size="12" maxlength="8">|;
  $template{'VER_PASSWORD_FIELD'} = qq|<input type="password" name="Verify_Password_RQ" size="12" maxlength="8">|;
  $template{'SUBMIT_BUTTON'} = qq|<input type="submit" name="submit" value="Submit This Data">|;
  
  parse_template("_account_add.htmlt", %template);
  &FUNCTIONS::cgi_works_footer();
} 

sub start_addition_procedure {
  my($new_username);
  &verify_input;
  
  $new_username = lc($FUNCTIONS::FORM{'Username_RQ'});
  if(-e "$VARIABLES::MEMBER_DATA_DIR/$new_username.mdf" || -e "$VARIABLES::MEMBER_DATA_DIR/$new_username.rdf") { 
    FUNCTIONS::data_error(1004, "Username Taken");
  }
  
  &send_confirmation_email($new_username);
  &create_files($new_username);
  &display_confirmation_page($new_username);
}

sub verify_input {
  my($key, $real_key, @ban_list);
  for $key (keys(%FUNCTIONS::FORM)) {
    $FUNCTIONS::FORM{$key} =~ s/\|//g;
    $real_key = $key; $real_key =~ s/_RQ//; $real_key =~ s/_/ /;
    FUNCTIONS::data_error(1001, "$real_key Left Blank") if($key =~ /_RQ/ && $FUNCTIONS::FORM{$key} eq "");
    FUNCTIONS::data_error(1002, "$real_key Malformed") if($key =~ /E-Mail/ && $FUNCTIONS::FORM{$key} !~ /^[\w\d][\w\d\,\.\-]*\@([\w\d\-]+\.)+([a-zA-Z]{3}|[a-zA-Z]{2})$/);
    FUNCTIONS::data_error(1002, "$real_key Malformed") if($key =~ /URL/ && $FUNCTIONS::FORM{$key} && $FUNCTIONS::FORM{$key} !~ /^http:\/\/[\w\d\-\.]+\.[\w\d\-\.]+/);
  }
  FUNCTIONS::data_error(1003, "Passwords Don't Match") if ($FUNCTIONS::FORM{Password_RQ} ne $FUNCTIONS::FORM{Verify_Password_RQ});
  FUNCTIONS::data_error(1020, "Invalid Username Entered") if($FUNCTIONS::FORM{'Username_RQ'} =~ /\s/gi);
  FUNCTIONS::data_error(1018, "Too Many Characters Entered") if(length($FUNCTIONS::FORM{'Site_Title_RQ'}) > $VARIABLES::TITLE_LENGTH && $VARIABLES::TITLE_LENGTH);
  FUNCTIONS::data_error(1019, "Too Many Characters Entered") if(length($FUNCTIONS::FORM{'Description_RQ'}) > $VARIABLES::DESC_LENGTH && $VARIABLES::DESC_LENGTH);
}

sub send_confirmation_email {
  my($username) = shift;
  open(MAIL, "|$VARIABLES::MAIL_COMMAND -t") || FUNCTIONS::script_error(1005, "sendmail");
  print MAIL "To: $FUNCTIONS::FORM{'E-Mail_RQ'}\nFrom: $VARIABLES::MY_EMAIL\n";
  print MAIL "Subject: Addition To $VARIABLES::SITE_TITLE\n\n";
  print MAIL "Your information has been added to our database.\n";
  print MAIL "You can begin sending hits to the list at any time\n";
  print MAIL "and you will be listed, if you send enough hits, at the\n";
  print MAIL "next update.  Below is your linking information.\n\n";
  print MAIL "URL to send hits to:\n";
  print MAIL "$VARIABLES::CGI_URL/rankem.cgi?action=in&id=$username\n\n";
  print MAIL "Your User ID: $username\n";
  print MAIL "Your Password: $FUNCTIONS::FORM{'Password_RQ'}\n\n";
  print MAIL "Thanks for joining,\nWebmaster, $VARIABLES::SITE_TITLE\n";
  print MAIL "$VARIABLES::FORWARD_URL";
  close (MAIL);
}
  
sub create_files {
  my($username) = shift;
  my $crypted_pass, my $ext = "mdf", my %md = %FUNCTIONS::FORM;
  $ext = "rdf" if($OPTIONS::REVIEW_ADDITIONS);
  $crypted_pass = crypt($md{'Password_RQ'}, "aa");
  
  open(MAIN, ">$VARIABLES::MEMBER_DATA_DIR/$username.$ext") || FUNCTIONS::script_error(1008, "$username.$ext");
  print MAIN "0|0|0|0|$md{'Site_URL_RQ'}|$md{'Site_Title_RQ'}|$md{'Description_RQ'}|$md{'E-Mail_RQ'}|$md{'Banner_URL'}|$crypted_pass";
  close(MAIN);
  chmod(0666, "$VARIABLES::MEMBER_DATA_DIR/$username.$ext") || FUNCTIONS::script_error(1009, "$username.$ext");
  
  unless($OPTIONS::REVIEW_ADDITIONS) {
    open(BACKUP, ">$VARIABLES::MEMBER_DATA_DIR/$username.bdf") || FUNCTIONS::script_error(1008, "$username.bdf");
    print BACKUP "0|0|0|0|$md{'Site_URL_RQ'}|$md{'Site_Title_RQ'}|$md{'Description_RQ'}|$md{'E-Mail_RQ'}|$md{'Banner_URL'}|$crypted_pass";
    close(BACKUP);
  }  
}

sub display_confirmation_page {
  my($user, %template) = shift;
  
  $template{'USERNAME'} = $user;
  $template{'PASSWORD'} = $FUNCTIONS::FORM{'Password_RQ'};
  $template{'EMAIL'} = $FUNCTIONS::FORM{'E-Mail_RQ'};
  $template{'SITE_TITLE'} = $FUNCTIONS::FORM{'Site_Title_RQ'};
  $template{'DESCRIPTION'} = $FUNCTIONS::FORM{'Description_RQ'};
  $template{'SITE_URL'} = $FUNCTIONS::FORM{'Site_URL_RQ'};
  $template{'BANNER_URL'} = $FUNCTIONS::FORM{'Banner_URL'};
  $template{'LINK_TO_URL'} = "$VARIABLES::CGI_URL/rankem.cgi?action=in&id=$user";
  $template{'BANNER_URL'} = '&nbsp;' if($template{'BANNER_URL'} eq "");

  parse_template("_account_added.htmlt", %template);
}

sub parse_template {
  my($page, %template) = @_;
  open(FILE, "$VARIABLES::TEMPLATE_DIR/$page") || FUNCTIONS::script_error(1020, $page);
  my @file_contents = <FILE>;
  close(FILE);
  
  for(@file_contents) {
    $_ =~ s/#%(.*?)%#/$template{$1}/gise;
  }

  print @file_contents;
}
