#!/usr/bin/perl
########################
##  AutoRank  v2.0.0  ##
###################################################################################
##  setup.cgi                                                                    ##
##  ---------                                                                    ##
##  This script controls the setup of AutoRank                                   ##
###################################################################################

require "functions.cgi";
package SETUP;

FUNCTIONS::parse();

if($ENV{'REQUEST_METHOD'} eq "GET") {
  print "Content-type: text/html\n\n";
  if($ENV{'QUERY_STRING'} eq "") {    &initialize; &display_main;  }
  elsif($ENV{'QUERY_STRING'} eq "verify")  {  &display_verify  }
  else {  print "Unknown Command"  }
}
elsif($ENV{'REQUEST_METHOD'} eq "POST") {
  if($FUNCTIONS::FORM{'submit'} eq "SAVE CONFIGURATION") {
    print "Content-type: text/html\n\n";
    FUNCTIONS::data_error(1000, "Invalid Administrative Password") unless(FUNCTIONS::password_is_valid($FUNCTIONS::FORM{'password'}));
    &verify_input;
    &edit_variables;
    &print_confirmation;
  } 
  elsif($FUNCTIONS::FORM{'submit'} eq "Change Password") {
    print "Content-type: text/html\n\n";
    &change_password;
  }
  else {  &display_main  }  
}

sub change_password {
  my($new_pass, $ver_new_pass, $crypted_pass) = ($FUNCTIONS::FORM{'new_pass'}, $FUNCTIONS::FORM{'ver_new_pass'});
  FUNCTIONS::data_error(1000, "Invalid Administrative Password") unless(FUNCTIONS::password_is_valid($FUNCTIONS::FORM{'cur_password'}));
  FUNCTIONS::data_error(1003, "Passwords Don't Match") unless($new_pass eq $ver_new_pass);
  
  $crypted_pass = crypt($new_pass, "aa");
  
  open(ADMINPASS, ">$FUNCTIONS::SCRIPT_DATA_DIR/admin.epf") || FUNCTIONS::script_error(1002, "admin.epf");
  print ADMINPASS "$crypted_pass";
  close(ADMINPASS);
  
  print qq|<div align="center"><font face="Verdana,Arial" size="2" color="red"><b>Administrative Password Successfully Updated</b></font></div>|;
  &display_main;
}

sub display_main {
  FUNCTIONS::header("AutoRank Setup");
  print <<HTML;
  <form action="setup.cgi" method="POST">
  <table cellpadding="1" cellspacing="0" border="0" align="center" width="600">
  <tr>
  <td bgcolor="#000000">
  <!-- INNER TABLE --> 
  <table cellpadding="5" cellspacing="1" border="0" width="100%">
  <tr>
  <td bgcolor="#afafaf" align="center" colspan="2">
  <font face="Arial" size="3">
  <b>AUTORANK SETUP</b><br>
  <font size="2" color="maroon">
  <b>Never Put a / at the End of a URL or Directory Path</b>
  </font>
  </font>
  </td>
  </tr>
  
  <tr>
  <td bgcolor="#dcdcdc" valign="top">
  <font face="Arial" size="2"><b>Directory Setup</b></font>
  </td>
  <td bgcolor="#ffffff">
  <font face="Verdana" size="1"><b>HTML Directory:</b></font><br>
  <input type="text" name="HTML_DIR_RQ" value="$VARIABLES::HTML_DIR" size="40"><br>
  <font face="Verdana" size="1">
  The full path to the location where the html list page will reside.<br>
  Example: /web/home/username/docs/autorank
  </font>
  <p>
  <font face="Verdana" size="1"><b>Member Data Directory:</b></font><br>
  <input type="text" name="MEMBER_DATA_DIR_RQ" value="$VARIABLES::MEMBER_DATA_DIR" size="40"><br>
  <font face="Verdana" size="1">
  The full path to the location where all member data files will reside.<br>
  Example: /web/home/username/cgi-bin/autorank/members
  </font>
  <p>
  <font face="Verdana" size="1"><b>Template Directory:</b></font><br>
  <input type="text" name="TEMPLATE_DIR_RQ" value="$VARIABLES::TEMPLATE_DIR" size="40"><br>
  <font face="Verdana" size="1">
  The full path to the location where all template data files will reside.<br>
  Example: /web/home/username/cgi-bin/autorank/templates
  </font>
  <p>
  <font face="Verdana" size="1"><b>Mail Command:</b></font><br>
  <input type="text" name="MAIL_COMMAND_RQ" value="$VARIABLES::MAIL_COMMAND" size="40"><br>
  <font face="Verdana" size="1">
  The full path to the location of your sendmail program.<br>
  Example: /usr/bin/sendmail
  </font>
  <p>
  </td>
  </tr>
  
  <tr>
  <td bgcolor="#dcdcdc" valign="top">
  <font face="Arial" size="2"><b>URL Setup</b></font>
  </td>
  <td bgcolor="#ffffff">
  <font face="Verdana" size="1"><b>CGI URL:</b></font><br>
  <input type="text" name="CGI_URL_RQ" value="$VARIABLES::CGI_URL" size="40"><br>
  <font face="Verdana" size="1">
  The full URL to the location where all cgi files will reside.<br>
  Example: http://www.domain.com/cgi-bin/autorank
  </font>
  <p>
  <font face="Verdana" size="1"><b>HTML URL:</b></font><br>
  <input type="text" name="HTML_URL_RQ" value="$VARIABLES::HTML_URL" size="40"><br>
  <font face="Verdana" size="1">
  The URL to where autorank.html will reside.<br>
  Example: http://www.domain.com/autorank
  </font>
  <p>
  </td>
  </tr>
  
  <tr>
  <td bgcolor="#dcdcdc" valign="top">
  <font face="Arial" size="2"><b>List Details</b></font>
  </td>
  <td bgcolor="#ffffff">
  <font face="Verdana" size="1"><b>Total Sites To List:</b></font><br>
  <input type="text" name="SITES_TO_LIST_RQ" value="$VARIABLES::SITES_TO_LIST" size="5"><br>
  <font face="Verdana" size="1">
  The total number of sites to be listed.<br>
  Example: 100
  </font>
  <p>
  <font face="Verdana" size="1"><b>Minimum Hits:</b></font><br>
  <input type="text" name="MINIMUM_HITS_RQ" value="$VARIABLES::MINIMUM_HITS" size="3"><br>
  <font face="Verdana" size="1">
  The minimum number of hits needed to get listed.<br>
  Example: 1
  </font>
  <p>
  <font face="Verdana" size="1"><b>Banners To Show:</b></font><br>
  <input type="text" name="NUM_OF_BANNERS_RQ" value="$VARIABLES::NUM_OF_BANNERS" size="3"><br>
  <font face="Verdana" size="1">
  The number of banners to show.<br>
  Example: 5
  </font>
  <p>
  <font face="Verdana" size="1"><b>Link Target:</b></font><br>
  <input type="text" name="TARGET" value="$VARIABLES::TARGET" size="30"><br>
  <font face="Verdana" size="1">
  The value to insert for the target portion of link html tags.<br>
  Example: new
  </font>
  <p>
  <font face="Verdana" size="1"><b>Site Title Max Length:</b></font><br>
  <input type="text" name="TITLE_LENGTH" value="$VARIABLES::TITLE_LENGTH" size="5"><br>
  <font face="Verdana" size="1">
  The maximum number of characters allowed for member site titles.<br>
  Example: 60
  </font>
  <p>
  <font face="Verdana" size="1"><b>Site Description Max Length:</b></font><br>
  <input type="text" name="DESC_LENGTH" value="$VARIABLES::DESC_LENGTH" size="5"><br>
  <font face="Verdana" size="1">
  The maximum number of characters allowed for member site descriptions.<br>
  Example: 255
  </font>
  <p>
  <font face="Verdana" size="1"><b>Site Title:</b></font><br>
  <input type="text" name="SITE_TITLE_RQ" value="$VARIABLES::SITE_TITLE" size="30"><br>
  <font face="Verdana" size="1">
  The title of your top list site.<br>
  Example: CGI Works Top 50
  </font>
  <p>
  <font face="Verdana" size="1"><b>E-Mail Address:</b></font><br>
  <input type="text" name="MY_EMAIL_RQ" value="$VARIABLES::MY_EMAIL" size="30"><br>
  <font face="Verdana" size="1">
  The e-mail address to associate with the list.<br>
  Example: you\@domain.com
  </font>
  <p>
  </td>
  </tr>
  
  <tr>
  <td bgcolor="#dcdcdc" valign="top">
  <font face="Arial" size="2"><b>Options</b></font>
  </td>
  <td bgcolor="#ffffff">
  <font face="Verdana" size="1">
  <b>Rerank time:</b></font><br>
  <input type="text" name="RERANK_TIME" value="$VARIABLES::RERANK_TIME" size="12"><br>
  <font face="Verdana" size="1">
  The number of seconds between list re-ranks<br>
  Example: 3600
  </font><p>
  <font face="Verdana" size="1"><b>Reset time:</b></font><br>
  <input type="text" name="RESET_TIME" value="$VARIABLES::RESET_TIME" size="12"><br>
  <font face="Verdana" size="1">
  The number of seconds between list resets<br>
  Example: 86400
  </font>
  <br>
  <hr size="1">
  <font face="Verdana" size="1">
  If you want to have all banners be the same size, fill in the following values<p>
  <b>Banner Height:</b></font><br>
  <input type="text" name="BANNER_HEIGHT" value="$VARIABLES::BANNER_HEIGHT" size="5"><br>
  <font face="Verdana" size="1">
  The height value to use for all banners.<br>
  Example: 60
  </font>
  <p>
  <font face="Verdana" size="1"><b>Banner Width:</b></font><br>
  <input type="text" name="BANNER_WIDTH" value="$VARIABLES::BANNER_WIDTH" size="5"><br>
  <font face="Verdana" size="1">
  The width value to use for all banners.<br>
  Example: 468
  </font>
  <p>
  </td>
  </tr>
  
  <tr>
  <td bgcolor="#dcdcdc" valign="top">
  <font face="Arial" size="2"><b>Table Setup</b></font>
  </td>
  <td bgcolor="#ffffff">
  <font face="Verdana" size="1"><b>Table Background Color:</b></font><br>
  <input type="text" name="BG_COLOR" value="$TABLE::BG_COLOR" size="15"><br>
  <font face="Verdana" size="1">
  The color to use for the table background.<br>
  Example: white
  </font>
  <p>
  <font face="Verdana" size="1"><b>Top Row Background Color:</b></font><br>
  <input type="text" name="TOP_BG_COLOR" value="$TABLE::TOP_BG_COLOR" size="15"><br>
  <font face="Verdana" size="1">
  The color to use for the background of the top row.<br>
  This is where RANK, SITE, IN, OUT are displayed.<br>
  Example: gray
  </font>
  <p>
  <font face="Verdana" size="1"><b>Font Face:</b></font><br>
  <input type="text" name="FONT_FACE" value="$TABLE::FONT_FACE" size="15"><br>
  <font face="Verdana" size="1">
  The font face to be used throughout the list.<br>
  Example: Arial
  </font>
  <p>
  <font face="Verdana" size="1"><b>Font Size:</b></font><br>
  <input type="text" name="FONT_SIZE" value="$TABLE::FONT_SIZE" size="5"><br>
  <font face="Verdana" size="1">
  The font size to be used throughout the list.<br>
  Example: 2
  </font>
  <p>
  <font face="Verdana" size="1"><b>Table Border:</b></font><br>
  <input type="text" name="BORDER" value="$TABLE::BORDER" size="5"><br>
  <font face="Verdana" size="1">
  The size of border to use for the table.<br>
  Example: 1
  </font>
  <p>
  <font face="Verdana" size="1"><b>Table Width:</b></font><br>
  <input type="text" name="WIDTH" value="$TABLE::WIDTH" size="5"><br>
  <font face="Verdana" size="1">
  The width value to use for the table.<br>
  Example: 600
  </font>
  <p>
  <font face="Verdana" size="1"><b>Table Cellspacing:</b></font><br>
  <input type="text" name="CSPACING" value="$TABLE::CSPACING" size="5"><br>
  <font face="Verdana" size="1">
  The cellspacing value to use for the table.<br>
  Example: 1
  </font>
  <p>
  <font face="Verdana" size="1"><b>Table Cellpadding:</b></font><br>
  <input type="text" name="CPADDING" value="$TABLE::CPADDING" size="5"><br>
  <font face="Verdana" size="1">
  The cellspacing value to use for the table.<br>
  Example: 3
  </font>
  <p>
  </td>
  </tr>
  
  </table>
  </td></tr></table>
  
  <p>
  
  <table cellpadding="1" cellspacing="0" border="0" align="center" width="300">
  <tr>
  <td bgcolor="#000000">
  <!-- INNER TABLE --> 
  <table cellpadding="5" cellspacing="1" border="0" width="100%">
  <tr>
  <td bgcolor="#afafaf" align="center">
  <font face="Arial" size="3">
  <b>Enter Your Password</b>
  </td>
  </tr>
  <tr>
  <td bgcolor="#dcdcdc" align="center">
  <font face="Arial" size="2">
  <b>Password: </b></font> <input type="password" name="password" size="12">
  </td>
  </tr>
  <tr>
  <td bgcolor="#ffffff" align="center">
  <input type="submit" name="submit" value="SAVE CONFIGURATION">
  </td>
  </tr>
  
  </table>
  </td></tr></table>
  
  <p>
  
  <table cellpadding="1" cellspacing="0" border="0" align="center" width="400">
  <tr>
  <td bgcolor="#000000">
  <!-- INNER TABLE --> 
  <table cellpadding="5" cellspacing="1" border="0" width="100%">
  <tr>
  <td bgcolor="#afafaf" align="center" colspan="2">
  <font face="Arial" size="3">
  <b>Change Administrative Password</b>
  </td>
  </tr>
  <tr>
  <td bgcolor="#dcdcdc" width="230">
  <font face="Verdana,Arial" size="2"><b>
  Current Password:
  </td>
  <td bgcolor="#ffffff" width="150">
  <input type="password" name="cur_password" size="12" maxlength="8">
  </td>
  </tr>
  <tr>
  <td bgcolor="#dcdcdc" width="230">
  <font face="Verdana,Arial" size="2"><b>
  New Password:
  </td>
  <td bgcolor="#ffffff" width="150">
  <input type="password" name="new_pass" size="12" maxlength="8">
  </td>
  </tr>
  <td bgcolor="#dcdcdc" width="230">
  <font face="Verdana,Arial" size="2"><b>
  Verify New Password:
  </td>
  <td bgcolor="#ffffff" width="150">
  <input type="password" name="ver_new_pass" size="12" maxlength="8">
  </td>
  </tr>
  <tr>
  <td align="center" bgcolor="#ffffff" colspan="2">
  <input type="submit" name="submit" value="Change Password">
  </td>
  </tr>
  </table>
  </td></tr></table>
HTML
}  

sub print_confirmation {
  FUNCTIONS::header("Setup Confirmation");
  FUNCTIONS::open_table("Variables Successfully Recorded");
  
  print <<HTML;
  <tr>
  <td bgcolor="#ffffff">
  <font face="Verdana,Arial" size="2">
  The variables have been successfully recorded to their data file.
  You should now verify your setup and variables by pointing your browser
  to the full URL of setup.cgi with the format http://www.domain.com/cgi-bin/setup.cgi?verify
  </td>
  </tr>
HTML
  FUNCTIONS::close_table();
}

sub initialize {
  unless(-e "$FUNCTIONS::SCRIPT_DATA_DIR/errors.dat") {
    print "Could not locate errors.dat in $FUNCTIONS::SCRIPT_DATA_DIR - Make sure this file exists";
    exit;
  }
  
  unless(-e "$FUNCTIONS::SCRIPT_DATA_DIR/admin.epf") {
    open(ADMINPASS, ">$FUNCTIONS::SCRIPT_DATA_DIR/admin.epf") || FUNCTIONS::script_error(1002, "admin.epf");
    print ADMINPASS crypt("admin", "aa");
    close(ADMINPASS);
    chmod(0666, "$FUNCTIONS::SCRIPT_DATA_DIR/admin.epf");
    print qq|<div align="center"><font face="Verdana,Arial" size="2" color="red"><b>Created administrative password file</b></font></div>|;
  }
}

sub verify_input {
  my($key, $real_key, @last_split, $last);
  for $key (keys(%FUNCTIONS::FORM)) {
    $FUNCTIONS::FORM{$key} =~ s/"//g;
    $real_key = $key; $real_key =~ s/_RQ//; $real_key =~ s/_/ /;
    FUNCTIONS::data_error(1001, "$real_key Left Blank") if($key =~ /_RQ/ && $FUNCTIONS::FORM{$key} eq "");
  }
}

sub edit_variables {
  my $time = time;
  open(VARS, ">$FUNCTIONS::SCRIPT_DATA_DIR/variables.dat") || FUNCTIONS::script_error(1016, "variables.dat");
  print VARS qq|package VARIABLES;\n|;
  print VARS qq|\$VARIABLES::SITE_TITLE       = "$FUNCTIONS::FORM{'SITE_TITLE_RQ'}"\;\n|;
  print VARS qq|\$VARIABLES::HTML_DIR         = "$FUNCTIONS::FORM{'HTML_DIR_RQ'}"\;\n|;
  print VARS qq|\$VARIABLES::MEMBER_DATA_DIR  = "$FUNCTIONS::FORM{'MEMBER_DATA_DIR_RQ'}"\;\n|;
  print VARS qq|\$VARIABLES::TEMPLATE_DIR     = "$FUNCTIONS::FORM{'TEMPLATE_DIR_RQ'}"\;\n|;
  print VARS qq|\$VARIABLES::MAIL_COMMAND     = "$FUNCTIONS::FORM{'MAIL_COMMAND_RQ'}"\;\n|;
  print VARS qq|\$VARIABLES::CGI_URL          = "$FUNCTIONS::FORM{'CGI_URL_RQ'}"\;\n|;
  print VARS qq|\$VARIABLES::HTML_URL         = "$FUNCTIONS::FORM{'HTML_URL_RQ'}"\;\n|;
  print VARS qq|\$VARIABLES::MY_EMAIL         = '$FUNCTIONS::FORM{'MY_EMAIL_RQ'}'\;\n|;
  print VARS qq|\$VARIABLES::SITES_TO_LIST    = '$FUNCTIONS::FORM{'SITES_TO_LIST_RQ'}'\;\n|;
  print VARS qq|\$VARIABLES::MINIMUM_HITS     = '$FUNCTIONS::FORM{'MINIMUM_HITS_RQ'}'\;\n|;
  print VARS qq|\$VARIABLES::NUM_OF_BANNERS   = '$FUNCTIONS::FORM{'NUM_OF_BANNERS_RQ'}'\;\n|;
  print VARS qq|\$VARIABLES::BANNER_HEIGHT    = '$FUNCTIONS::FORM{'BANNER_HEIGHT'}'\;\n|;
  print VARS qq|\$VARIABLES::BANNER_WIDTH     = '$FUNCTIONS::FORM{'BANNER_WIDTH'}'\;\n|;
  print VARS qq|\$VARIABLES::RERANK_TIME      = '$FUNCTIONS::FORM{'RERANK_TIME'}'\;\n|;
  print VARS qq|\$VARIABLES::RESET_TIME       = '$FUNCTIONS::FORM{'RESET_TIME'}'\;\n|;
  print VARS qq|\$VARIABLES::TITLE_LENGTH     = '$FUNCTIONS::FORM{'TITLE_LENGTH'}'\;\n|;
  print VARS qq|\$VARIABLES::DESC_LENGTH      = '$FUNCTIONS::FORM{'DESC_LENGTH'}'\;\n|;
  print VARS qq|\$VARIABLES::TARGET           = "$FUNCTIONS::FORM{'TARGET'}";\n|;
  print VARS qq|\%VARIABLES::PAGE_DATA        = ();\n|;
  print VARS qq|package TABLE;\n|;
  print VARS qq|\$TABLE::BG_COLOR             = '$FUNCTIONS::FORM{'BG_COLOR'}'\;\n|;
  print VARS qq|\$TABLE::TOP_BG_COLOR         = '$FUNCTIONS::FORM{'TOP_BG_COLOR'}'\;\n|;
  print VARS qq|\$TABLE::FONT_FACE            = '$FUNCTIONS::FORM{'FONT_FACE'}'\;\n|;
  print VARS qq|\$TABLE::FONT_SIZE            = '$FUNCTIONS::FORM{'FONT_SIZE'}'\;\n|;
  print VARS qq|\$TABLE::BORDER               = '$FUNCTIONS::FORM{'BORDER'}'\;\n|;
  print VARS qq|\$TABLE::WIDTH                = '$FUNCTIONS::FORM{'WIDTH'}'\;\n|;
  print VARS qq|\$TABLE::CSPACING             = '$FUNCTIONS::FORM{'CSPACING'}'\;\n|;
  print VARS qq|\$TABLE::CPADDING             = '$FUNCTIONS::FORM{'CPADDING'}'\;\n|;
  print VARS qq|1\; # Return true\n|;
  close(VARS);
  
  unless(-e "$FUNCTIONS::SCRIPT_DATA_DIR/time.dat") {
    open(TIME, ">$FUNCTIONS::SCRIPT_DATA_DIR/time.dat") || FUNCTIONS::script_error(1019, "time.dat");
    print TIME "package TIME;\n";
    print TIME "\$TIME::RERANK = $time;\n";
    print TIME "\$TIME::RESET  = $time;\n";
    print TIME "1;";
    close(TIME);
    chmod(0666, "$FUNCTIONS::SCRIPT_DATA_DIR/time.dat");
  } 
}

sub display_verify {
  FUNCTIONS::header("Setup Verification");
  print qq|<font face="Verdana,Arial" size="1">CURRENT TIME: $FUNCTIONS::CURRENT_DATE</font><p>|;
  FUNCTIONS::open_table("AutoRank Setup Verification", "", 2);
  
  print <<HTML;
  <tr bgcolor="#dcdcdc">
  <td align="center">
  <font face="Verdana,Arial" size="1"><b>TEST
  </td>
  <td align="center">
  <font face="Verdana,Arial" size="1"><b>TEST RESULT
  </td>
  </tr>
  <tr bgcolor="#ffffff">
  <td align="center">
  <font face="Verdana,Arial" size="1">File Manipulation In Member Data Directory
  </td>
  <td align="center">
  <font face="Verdana,Arial" size="1">
HTML

  print test($VARIABLES::MEMBER_DATA_DIR, 1);
  
  print <<HTML;
  </td>
  </tr>
  <tr bgcolor="#ffffff">
  <td align="center">
  <font face="Verdana,Arial" size="1">File Manipulation In Script Data Directory
  </td>
  <td align="center">
  <font face="Verdana,Arial" size="1">
HTML

  print test($FUNCTIONS::SCRIPT_DATA_DIR, 1);
  
  print <<HTML;
  </td>
  </tr>
  <tr bgcolor="#ffffff">
  <td align="center">
  <font face="Verdana,Arial" size="1">File Manipulation In HTML Directory
  </td>
  <td align="center">
  <font face="Verdana,Arial" size="1">
HTML

  print test($VARIABLES::HTML_DIR, 1);
  
  print <<HTML;
  </td>
  </tr>
  <tr bgcolor="#ffffff">
  <td align="center">
  <font face="Verdana,Arial" size="1">Permissions check on accounts.cgi
  </td>
  <td align="center">
  <font face="Verdana,Arial" size="1">
HTML

  print test("accounts.cgi", 2);
  
  print <<HTML;
  </td>
  </tr>
  <tr bgcolor="#ffffff">
  <td align="center">
  <font face="Verdana,Arial" size="1">Permissions check on out.cgi
  </td>
  <td align="center">
  <font face="Verdana,Arial" size="1">
HTML

  print test("out.cgi", 2);
  
  print <<HTML;
  </td>
  </tr>
  <tr bgcolor="#ffffff">
  <td align="center">
  <font face="Verdana,Arial" size="1">Permissions check on rankem.cgi
  </td>
  <td align="center">
  <font face="Verdana,Arial" size="1">
HTML

  print test("rankem.cgi", 2);
  
  print <<HTML;
  </td>
  </tr>
HTML
  FUNCTIONS::close_table();
  
  FUNCTIONS::open_table("Information");
  print <<HTML;
  <tr bgcolor="#ffffff">
  <td>
  <font face="Verdana,Arial" size="1">
  If all of the above tests have passed, you should be ready to start running your list.
  If this is your first time setting up the script, have a look at the documentation to
  see what you need to do to get your list completely setup and ready to use.
  </td>
  </tr>
HTML
  FUNCTIONS::close_table();
}

sub test {
  my($thing_to_test, $test_type) = @_;
  if($test_type == 1) {
    open(TESTFILE, ">$thing_to_test/test.file") || return "<font color='red'>Failed!</font><br>Could Not Create File<br>$!";
    print TESTFILE "TEST PASSED!";
    close(TESTFILE);
    chmod(0666, "$thing_to_test/test.file") || return "<font color='red'>Failed!</font><br>Could Not Change Permissions on File<br>$!";
    unlink("$thing_to_test/test.file") || return "<font color='red'>Failed!</font><br>Could Not Remove File<br>$!";
    return "<font color='blue'>Passed</font>";
  }
  elsif($test_type == 2) {
    my %perms = (16895 => 777, 33279 => 777, 33261 => 755, 16877 => 755,
                 33204 => 664, 16820 => 664, 33188 => 644, 16804 => 644,
                 33060 => 444, 16676 => 444, 33206 => 666, 16822 => 666,
                 33277 => 775, 16893 => 775, 33270 => 766, 16886 => 766,
                 33252 => 744, 16868 => 744, 33276 => 774, 16892 => 774);
    
    return "<font color='red'>Failed!</font><br>Incorrect Permissions" if($perms{(stat("$thing_to_test"))[2]} != 755);
    return "<font color='blue'>Passed</font>";
  }
}

sub get_checkbox_value {
  my $value = shift;
  return " checked>" if($value);
  return ">";
}
